//============================================================================
// Name        : wsock.cpp
// Author      : 
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C, Ansi-style
//============================================================================

//** Windows 7 以降
#define _WIN32_WINNT _WIN32_WINNT_WIN7

#include <stdio.h>
#include <stdlib.h>
#include <winsock2.h>
#include <ws2tcpip.h>
//#include <windows.h>

bool IPv6=false;
bool server=true;

int port=7777;
const char* host="localhost";

ADDRINFOW*aiList;

//*************************************
//**  接続相手の情報
//*************************************
void getPeer(SOCKET sock)
{
  int ec,xport,len;
  SOCKADDR_IN* adr4;
  SOCKADDR_IN6 adr;
  char*px;
  char peerIP[100],peerName[1000],buf1[1000];
  
  len=sizeof(adr);
  ec=::getpeername(sock,(SOCKADDR*)&adr,&len);
  if(ec==SOCKET_ERROR){
    ec=WSAGetLastError();
    printf("getpeername error %d\n",ec);
    return;
    }

  xport=ntohs(adr.sin6_port);

  if(adr.sin6_family==AF_INET){
      adr4=(SOCKADDR_IN*)&adr;
      px=(char*)inet_ntop(AF_INET,&(adr4->sin_addr),peerIP,100);
      }
    else{
      px=(char*)inet_ntop(AF_INET6,&adr.sin6_addr,peerIP,100);
      }
  if(!px) return ;

  ec=getnameinfo((const sockaddr*)&adr,sizeof(SOCKADDR_IN6),peerName,1000,buf1,1000,0);
  if(ec) {
	 ec=GetLastError();
	 printf("getnameinfo error %d\n",ec);
     return;
     }

  printf("接続相手  port %d [%s] [%s]\n",xport,peerIP,peerName);
  }
//*************************************
//** ソケットの作成 **************
//*************************************
SOCKET createSocket()
{
  SOCKET xsock;
  ADDRINFOW hints;
  wchar_t wport[1000],whost[1000];
  char buf[100];
  int ec;

  memset(&hints, 0, sizeof(hints));
  hints.ai_flags=AI_CANONNAME;
  if(server) hints.ai_flags|=AI_PASSIVE;
  hints.ai_family = IPv6 ? AF_INET6:AF_INET;
  hints.ai_socktype = SOCK_STREAM;
  hints.ai_protocol = IPPROTO_TCP;
  
  MultiByteToWideChar(CP_UTF8, 0, host, -1, whost, 1000);
  sprintf(buf,"%d",port);
  MultiByteToWideChar(CP_UTF8, 0, buf, -1, wport, 100);
  
  ec= GetAddrInfoW(whost,wport, &hints, &aiList);
  if(ec) {
	  ec=WSAGetLastError();
	  printf("GetAddrInfo のエラー  %x",ec);
	  return INVALID_SOCKET;
      }
      
  
  if(aiList->ai_canonname){
    WideCharToMultiByte(CP_UTF8, 0, aiList->ai_canonname, -1, buf, 1000, nullptr, nullptr);
    printf("trueName= [%s]\n",buf);
    };
    
  
  xsock = socket(aiList->ai_family, aiList->ai_socktype, aiList->ai_protocol);
  if(xsock==INVALID_SOCKET){
	 ec=WSAGetLastError();
     FreeAddrInfoW(aiList);
     printf("ソケットの作成に失敗しました %x\n",ec);
     }
        
  return xsock;    
  }

//*************************************
//** クライアントのテスト *************
//*************************************
void testClient()
{
  SOCKET sock=createSocket();
  int ec;
  char buf[110];

  if(sock==INVALID_SOCKET) return;
 
  ec=connect(sock, aiList->ai_addr, aiList->ai_addrlen);
  if(ec==SOCKET_ERROR){
	  ec=WSAGetLastError();
	  printf("接続のエラー %d\n",ec);
      goto term;
      }
  getPeer(sock);

  ec=recv(sock,buf,100,0);
  if(ec==SOCKET_ERROR){
	  ec=WSAGetLastError();
	  printf("読込のエラー %d\n",ec);
      goto term;
      }
  buf[ec]=0;   
  printf("受信しました [%s]\n",buf);
 
term:;
  FreeAddrInfoW(aiList);
  closesocket(sock);
      
  }
//*************************************
//** サーバーのテスト *************
//*************************************
void testServer()
{
  SOCKET sock=createSocket(),asock;
  struct sockaddr_in6 adr;
  SOCKADDR_STORAGE client;
  int ec,adrSize = sizeof(client);
  const char* msg="I am Server!";

  if(sock==INVALID_SOCKET) return;
  
  memset(&adr,0,sizeof(adr));
  memcpy(&adr,aiList->ai_addr,4);
  ec=bind(sock,(sockaddr*)&adr, (int)aiList->ai_addrlen);
  if(ec){
      ec=GetLastError();
      printf("bind error %d\n",ec);
      goto term;}

  ec=listen(sock,SOMAXCONN);
  if(ec){
	  ec=GetLastError();
      printf("listen error %d ",ec);	  
      goto term;
      }
      
  for(int i=0;i<3;i++){
    printf( "クライアントからの接続をまってます\n" );
    
    asock=accept(sock,(SOCKADDR *)&client , &adrSize);
    if(asock==INVALID_SOCKET){
      ec=GetLastError();
      printf("accept error %d\n",ec);
      goto term;;
      }

    printf( "クライアントからの接続を受け付けました。メッセージを送信します\n" );
    getPeer(asock);
    ec=send(asock,msg,strlen(msg),0);
    if(ec==SOCKET_ERROR){
	  ec=WSAGetLastError();
      printf("送信 error %d\n",ec);
      goto term;;
      }
     
    closesocket(asock);
    }
  printf( "サーバーを終了します。\n" );

term:;
  FreeAddrInfoW(aiList);
  closesocket(sock);
  }
//*************************************
//** メイン  *****************************
//*************************************
int main(void) {
	
  int ec;
  WSADATA wsaData;
  
  ec=WSAStartup(WINSOCK_VERSION, &wsaData);
  if(ec){
      printf("Winsock の初期化に失敗しました %d\n",ec);
      return ec;
      }

  printf("<<%s:%s %x %x>>\n",wsaData.szDescription,wsaData.szSystemStatus
           ,wsaData.wVersion,wsaData.wHighVersion);

  if(server) testServer();else testClient();
      
  WSACleanup();     
  return EXIT_SUCCESS;
}
